import './Badge.css';
import React from 'react';
import { IconProps } from '../../icons/Icon/Icon';
export declare const badgePropSize: readonly ["m", "s", "l"];
export declare type BadgePropSize = typeof badgePropSize[number];
export declare const badgePropSizeDefault: BadgePropSize;
export declare const badgePropView: readonly ["filled", "stroked"];
export declare type BadgePropView = typeof badgePropView[number];
export declare const badgePropViewDefault: BadgePropView;
export declare const badgePropStatus: readonly ["normal", "success", "error", "warning", "system"];
export declare type BadgePropStatus = typeof badgePropStatus[number];
export declare const badgePropStatusDefault: BadgePropStatus;
export declare const badgePropForm: readonly ["default", "round"];
export declare type BadgePropForm = typeof badgePropForm[number];
export declare const badgePropFormDefault: BadgePropForm;
declare type Props = {
    size?: BadgePropSize;
    view?: BadgePropView;
    status?: BadgePropStatus;
    form?: BadgePropForm;
    minified?: boolean;
    icon?: React.FC<IconProps>;
    label?: string;
    children?: never;
};
export declare const cnBadge: {
    (): string;
    (elemNameOrBlockMods: null, elemMix: import("@bem-react/classname").ClassNameList): string;
    (elemNameOrBlockMods: string | Record<string, string | number | boolean | undefined>, elemModsOrBlockMix?: Record<string, string | number | boolean | undefined> | import("@bem-react/classname").ClassNameList | null | undefined, elemMix?: import("@bem-react/classname").ClassNameList | undefined): string;
};
export declare const Badge: import("../../utils/types/PropsWithAsAttributes").ComponentWithAs<Props, "div">;
export {};
