import './Button.css';
import React from 'react';
import { IconProps, IconPropSize } from '../../icons/Icon/Icon';
export declare const buttonPropSize: readonly ["m", "xs", "s", "l"];
export declare type ButtonPropSize = typeof buttonPropSize[number];
export declare const buttonPropSizeDefault: ButtonPropSize;
export declare const buttonPropView: readonly ["primary", "clear", "ghost", "secondary"];
export declare type ButtonPropView = typeof buttonPropView[number];
export declare const buttonPropViewDefault: ButtonPropView;
export declare const buttonPropWidth: readonly ["default", "full"];
export declare type ButtonPropWidth = typeof buttonPropWidth[number];
export declare const buttonPropWidthDefault: ButtonPropWidth;
export declare const buttonPropForm: readonly ["default", "brick", "round", "brickRound", "roundBrick", "brickDefault", "defaultBrick"];
export declare type ButtonPropForm = typeof buttonPropForm[number];
export declare const buttonPropFormDefault: ButtonPropForm;
export declare type Props = {
    size?: ButtonPropSize;
    view?: ButtonPropView;
    width?: ButtonPropWidth;
    form?: ButtonPropForm;
    tabIndex?: number;
    disabled?: boolean;
    loading?: boolean;
    label?: string | number;
    onClick?: React.EventHandler<React.MouseEvent>;
    iconLeft?: React.FC<IconProps>;
    iconRight?: React.FC<IconProps>;
    onlyIcon?: boolean;
    iconSize?: IconPropSize;
    title?: string;
    children?: never;
};
export declare const cnButton: {
    (): string;
    (elemNameOrBlockMods: null, elemMix: import("@bem-react/classname").ClassNameList): string;
    (elemNameOrBlockMods: string | Record<string, string | number | boolean | undefined>, elemModsOrBlockMix?: Record<string, string | number | boolean | undefined> | import("@bem-react/classname").ClassNameList | null | undefined, elemMix?: import("@bem-react/classname").ClassNameList | undefined): string;
};
export declare const Button: import("../../utils/types/PropsWithAsAttributes").ComponentWithAs<Props, "button">;
