"use strict";
exports.__esModule = true;
exports.getGroups = exports.contextMenuPropDefaultSubMenuDirection = exports.contextMenuPropSubMenuDirections = exports.contextMenuAccent = exports.contextMenuDefaultSize = exports.contextMenuSizes = exports.defaultGroupId = void 0;
var tslib_1 = require("tslib");
exports.defaultGroupId = 'context-menu-no-group';
exports.contextMenuSizes = ['m', 's', 'l'];
exports.contextMenuDefaultSize = exports.contextMenuSizes[0];
exports.contextMenuAccent = ['alert', 'warning', 'success'];
exports.contextMenuPropSubMenuDirections = [
    'rightStartUp',
    'rightStartDown',
    'leftStartUp',
    'leftStartDown',
];
exports.contextMenuPropDefaultSubMenuDirection = exports.contextMenuPropSubMenuDirections[0];
function getGroups(items, getGroupId, sortGroup) {
    var e_1, _a;
    if (typeof getGroupId === 'function') {
        var groups = [];
        var _loop_1 = function (item) {
            var id = getGroupId(item) || exports.defaultGroupId;
            var index = groups.findIndex(function (group) { return group.id === id; });
            if (index >= 0) {
                groups[index].items.push(item);
            }
            else {
                var group = { id: id, items: [item] };
                groups.push(group);
            }
        };
        try {
            for (var items_1 = tslib_1.__values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
                var item = items_1_1.value;
                _loop_1(item);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (items_1_1 && !items_1_1.done && (_a = items_1["return"])) _a.call(items_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (typeof sortGroup === 'function') {
            groups.sort(function (a, b) { return sortGroup(a.id, b.id); });
        }
        return groups;
    }
    return [{ items: items, id: exports.defaultGroupId }];
}
exports.getGroups = getGroups;
