import './SwitchGroup.css';
import React from 'react';
import { PropsWithHTMLAttributesAndRef } from '../../utils/types/PropsWithHTMLAttributes';
export declare const cnSwitchGroup: {
    (): string;
    (elemNameOrBlockMods: null, elemMix: import("@bem-react/classname").ClassNameList): string;
    (elemNameOrBlockMods: string | Record<string, string | number | boolean | undefined>, elemModsOrBlockMix?: Record<string, string | number | boolean | undefined> | import("@bem-react/classname").ClassNameList | null | undefined, elemMix?: import("@bem-react/classname").ClassNameList | undefined): string;
};
export declare const switchGroupDirections: readonly ["column", "row"];
export declare type SwitchGroupDirection = typeof switchGroupDirections[number];
export declare const switchGroupDefaultDirection: SwitchGroupDirection;
export declare const switchGroupSizes: readonly ["m", "l"];
export declare type SwitchGroupPropSize = typeof switchGroupSizes[number];
export declare const switchGroupDefaultSize: SwitchGroupPropSize;
export declare const switchGroupViews: readonly ["primary", "ghost"];
export declare type SwitchGroupPropView = typeof switchGroupViews[number];
export declare const switchGroupDefaultView: SwitchGroupPropView;
declare type CommonProps<ITEM> = {
    value?: ITEM[] | null;
    items: ITEM[];
    getLabel: (item: ITEM) => string;
    getDisabled?: (item: ITEM) => boolean | undefined;
    onChange: (props: {
        e: React.ChangeEvent<HTMLInputElement>;
        value: ITEM[] | null;
    }) => void;
    name: string;
    direction?: SwitchGroupDirection;
    size?: SwitchGroupPropSize;
    view?: SwitchGroupPropView;
    disabled?: boolean;
    className?: string;
};
declare type Props<ITEM> = PropsWithHTMLAttributesAndRef<CommonProps<ITEM>, HTMLDivElement>;
declare type SwitchGroup = <ITEM>(props: Props<ITEM>) => React.ReactElement | null;
export declare const SwitchGroup: SwitchGroup;
export {};
