import './Tabs.css';
import React from 'react';
import { IconProps, IconPropSize } from '../../icons/Icon/Icon';
import { PropsWithHTMLAttributesAndRef } from '../../utils/types/PropsWithHTMLAttributes';
import { cnTabsTab, TabsTab } from './Tab/TabsTab';
export declare const tabsSizes: readonly ["m", "s"];
export declare type TabsPropSize = typeof tabsSizes[number];
export declare const tabsDefaultSize: TabsPropSize;
export declare const tabsViews: readonly ["bordered", "clear"];
export declare type TabsPropView = typeof tabsViews[number];
export declare const tabsDefaultView: TabsPropView;
export declare type TabsPropGetLabel<ITEM> = (item: ITEM) => string | number;
export declare type TabsPropGetIcon<ITEM> = (item: ITEM) => React.FC<IconProps> | undefined;
export declare type TabsPropOnChange<ITEM, ITEM_ELEMENT> = (props: {
    e: React.MouseEvent<ITEM_ELEMENT>;
    value: ITEM;
}) => void;
declare type RenderItemProps<ITEM, ELEMENT extends HTMLElement> = {
    item: ITEM;
    ref: React.RefObject<ELEMENT>;
    key: string | number;
    onChange: React.MouseEventHandler<ELEMENT>;
    checked: boolean;
    label: string;
    icon?: React.FC<IconProps>;
    iconSize: IconPropSize;
    onlyIcon?: boolean;
    className: string;
};
declare type RenderItem<ITEM, ELEMENT extends HTMLElement> = (props: RenderItemProps<ITEM, ELEMENT>) => React.ReactElement | null;
export declare type TabsProps<ITEM, ITEM_ELEMENT extends HTMLElement = HTMLButtonElement> = PropsWithHTMLAttributesAndRef<{
    size?: TabsPropSize;
    onlyIcon?: boolean;
    view?: TabsPropView;
    iconSize?: IconPropSize;
    items: ITEM[];
    value?: ITEM | null;
    getIcon?: TabsPropGetIcon<ITEM>;
    getLabel: TabsPropGetLabel<ITEM>;
    children?: never;
    onChange: TabsPropOnChange<ITEM, ITEM_ELEMENT>;
    renderItem?: RenderItem<ITEM, ITEM_ELEMENT>;
}, HTMLDivElement>;
declare type Tabs = <ITEM, ITEMELEMENT extends HTMLElement = HTMLButtonElement>(props: TabsProps<ITEM, ITEMELEMENT>, ref: React.Ref<HTMLDivElement>) => React.ReactElement | null;
export declare const cnTabs: {
    (): string;
    (elemNameOrBlockMods: null, elemMix: import("@bem-react/classname").ClassNameList): string;
    (elemNameOrBlockMods: string | Record<string, string | number | boolean | undefined>, elemModsOrBlockMix?: Record<string, string | number | boolean | undefined> | import("@bem-react/classname").ClassNameList | null | undefined, elemMix?: import("@bem-react/classname").ClassNameList | undefined): string;
};
export declare const Tabs: Tabs;
export { TabsTab, cnTabsTab };
