import './TagBase.css';
import React from 'react';
import { IconProps, IconPropSize } from '../../icons/Icon/Icon';
export declare const tagBasePropSize: readonly ["m", "xs", "s", "l"];
export declare const tagBasePropSizeDefault: "m";
export declare type TagBasePropSize = typeof tagBasePropSize[number];
export declare const tagBasePropGroupNumberValue: readonly [1, 2, 3, 4, 5, 6, 7, 8, 9];
export declare const tagBasePropGroupStringValue: readonly ["1", "2", "3", "4", "5", "6", "7", "8", "9"];
export declare const tagBasePropGroup: ("1" | 2 | 1 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9")[];
export declare type TagBasePropGroup = typeof tagBasePropGroup[number];
export declare const tagBasePropView: readonly ["stroked", "filled"];
export declare const tagBasePropViewDefault: "stroked";
export declare type TagBasePropView = typeof tagBasePropView[number];
export declare type Props = {
    size?: TagBasePropSize;
    label: string;
    children?: never;
    view?: TagBasePropView;
    group?: TagBasePropGroup;
    onCancel?: React.MouseEventHandler<HTMLButtonElement>;
    icon?: React.FC<IconProps>;
    iconSize?: IconPropSize;
    withAction?: boolean;
};
export declare const cnTagBase: {
    (): string;
    (elemNameOrBlockMods: null, elemMix: import("@bem-react/classname").ClassNameList): string;
    (elemNameOrBlockMods: string | Record<string, string | number | boolean | undefined>, elemModsOrBlockMix?: Record<string, string | number | boolean | undefined> | import("@bem-react/classname").ClassNameList | null | undefined, elemMix?: import("@bem-react/classname").ClassNameList | undefined): string;
};
export declare const TagBase: import("../../utils/types/PropsWithAsAttributes").ComponentWithAs<Props, "div">;
