import './Text.css';
export declare const textPropAlign: readonly ["left", "center", "right"];
export declare type TextPropAlign = typeof textPropAlign[number];
export declare const textPropDisplay: readonly ["block", "inlineBlock", "inline"];
export declare type TextPropDisplay = typeof textPropDisplay[number];
export declare const textPropFont: readonly ["primary", "mono"];
export declare type TextPropFont = typeof textPropFont[number];
export declare const textPropDecoration: readonly ["underline"];
export declare type TextPropDecoration = typeof textPropDecoration[number];
export declare const textPropLineHeight: readonly ["2xs", "xs", "s", "m", "l"];
export declare type TextPropLineHeight = typeof textPropLineHeight[number];
export declare const textPropSize: readonly ["m", "2xs", "xs", "s", "l", "xl", "2xl", "3xl", "4xl", "5xl", "6xl"];
export declare type TextPropSize = typeof textPropSize[number];
export declare const textPropSizeDefault: TextPropSize;
export declare const textPropSpacing: readonly ["xs", "s", "m", "l"];
export declare type TextPropSpacing = typeof textPropSpacing[number];
export declare const textPropType: readonly ["blockquote", "p", "h3", "h2", "h1"];
export declare type TextPropType = typeof textPropType[number];
export declare const textPropView: readonly ["primary", "alert", "brand", "ghost", "link", "linkMinor", "primary", "secondary", "success", "warning"];
export declare type TextPropView = typeof textPropView[number];
export declare const textPropViewDefault: TextPropView;
export declare const textPropWeight: readonly ["black", "bold", "light", "regular", "semibold", "thin"];
export declare type TextPropWeight = typeof textPropWeight[number];
export declare const textPropFontStyle: readonly ["italic"];
export declare type TextPropFontStyle = typeof textPropFontStyle[number];
export declare const textPropTransform: readonly ["uppercase"];
export declare type TextPropTransform = typeof textPropTransform[number];
export declare const textPropWidth: readonly ["default"];
export declare type TextPropWidth = typeof textPropWidth[number];
declare type Props = {
    align?: TextPropAlign;
    decoration?: TextPropDecoration;
    display?: TextPropDisplay;
    font?: TextPropFont;
    lineHeight?: TextPropLineHeight;
    size?: TextPropSize;
    spacing?: TextPropSpacing;
    fontStyle?: TextPropFontStyle;
    transform?: TextPropTransform;
    type?: TextPropType;
    view?: TextPropView;
    weight?: TextPropWeight;
    width?: TextPropWidth;
};
export declare const cnText: {
    (): string;
    (elemNameOrBlockMods: null, elemMix: import("@bem-react/classname").ClassNameList): string;
    (elemNameOrBlockMods: string | Record<string, string | number | boolean | undefined>, elemModsOrBlockMix?: Record<string, string | number | boolean | undefined> | import("@bem-react/classname").ClassNameList | null | undefined, elemMix?: import("@bem-react/classname").ClassNameList | undefined): string;
};
export declare const Text: import("../../utils/types/PropsWithAsAttributes").ComponentWithAs<Props, "div">;
export {};
