"use strict";
exports.__esModule = true;
exports.useChoiceGroup = void 0;
var tslib_1 = require("tslib");
function formatValue(valueProp, getKey, multiple) {
    var e_1, _a;
    var valueByKey = {};
    if (!valueProp) {
        return valueByKey;
    }
    var value = multiple ? valueProp : [valueProp];
    if (value && value.length > 0) {
        try {
            for (var value_1 = tslib_1.__values(value), value_1_1 = value_1.next(); !value_1_1.done; value_1_1 = value_1.next()) {
                var item = value_1_1.value;
                valueByKey[getKey(item)] = item;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (value_1_1 && !value_1_1.done && (_a = value_1["return"])) _a.call(value_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    return valueByKey;
}
function useChoiceGroup(_a) {
    var valueProp = _a.value, getKey = _a.getKey, callBackProp = _a.callBack, multiple = _a.multiple;
    var formatedValue = formatValue(valueProp, getKey, multiple);
    var getChecked = function (item) {
        return Object.prototype.hasOwnProperty.call(formatedValue, getKey(item));
    };
    var getOnChange = function (item) { return function (e) {
        var checked = getChecked(item);
        var key = getKey(item);
        if (multiple) {
            var newValue = void 0;
            if (checked) {
                var value = valueProp ? valueProp : [];
                newValue = value.filter(function (item) { return getKey(item) !== key; });
                if (newValue.length === 0) {
                    newValue = null;
                }
            }
            else {
                newValue = valueProp ? tslib_1.__spread(valueProp) : [];
                newValue.push(item);
            }
            var callBack = callBackProp;
            callBack({ e: e, value: newValue });
        }
        else {
            var callBack = callBackProp;
            callBack({ e: e, value: item });
        }
    }; };
    return {
        getOnChange: getOnChange,
        getChecked: getChecked
    };
}
exports.useChoiceGroup = useChoiceGroup;
