"use strict";
exports.__esModule = true;
exports.useDebounce = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
exports.useDebounce = function (fn, time) {
    if (time === void 0) { time = 0; }
    var ref = react_1["default"].useRef(null);
    var fnRef = react_1["default"].useRef();
    fnRef.current = fn;
    react_1["default"].useEffect(function () {
        return function () {
            ref.current && clearTimeout(ref.current);
        };
    }, [time]);
    return react_1["default"].useCallback(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (ref.current) {
            clearTimeout(ref.current);
        }
        ref.current = setTimeout(function () {
            ref.current = null;
            if (typeof fnRef.current === 'function') {
                fnRef.current.apply(fnRef, tslib_1.__spread(args));
            }
        }, time);
    }, [time]);
};
