import { __assign, __read, __rest } from "tslib";
import '../SelectComponents/Select.css';
import React, { useRef, useState } from 'react';
import { useSelect } from '../../hooks/useSelect/useSelect';
import { IconSelect } from '../../icons/IconSelect/IconSelect';
import { scrollIntoView } from '../../utils/scrollIntoView';
import { usePropsHandler } from '../EventInterceptor/usePropsHandler';
import { cnSelect } from '../SelectComponents/cnSelect';
import { getSelectDropdownForm } from '../SelectComponents/helpers';
import { SelectContainer } from '../SelectComponents/SelectContainer/SelectContainer';
import { SelectDropdown } from '../SelectComponents/SelectDropdown/SelectDropdown';
import { DefaultPropForm, DefaultPropSize, DefaultPropView, } from '../SelectComponents/types';
export var BasicSelect = function (props) {
    var defaultOptionsRef = useRef(null);
    var controlRef = useRef(null);
    var _a = usePropsHandler(cnSelect(), props, controlRef), placeholder = _a.placeholder, onBlur = _a.onBlur, onFocus = _a.onFocus, options = _a.options, onChange = _a.onChange, value = _a.value, getOptionLabel = _a.getOptionLabel, disabled = _a.disabled, ariaLabel = _a.ariaLabel, id = _a.id, _b = _a.dropdownRef, dropdownRef = _b === void 0 ? defaultOptionsRef : _b, _c = _a.form, form = _c === void 0 ? DefaultPropForm : _c, _d = _a.view, view = _d === void 0 ? DefaultPropView : _d, _e = _a.size, size = _e === void 0 ? DefaultPropSize : _e, dropdownClassName = _a.dropdownClassName, name = _a.name, restProps = __rest(_a, ["placeholder", "onBlur", "onFocus", "options", "onChange", "value", "getOptionLabel", "disabled", "ariaLabel", "id", "dropdownRef", "form", "view", "size", "dropdownClassName", "name"]);
    var toggleRef = useRef(null);
    var _f = __read(useState(false), 2), isFocused = _f[0], setIsFocused = _f[1];
    var handlerChangeValue = function (v) {
        if (typeof onChange === 'function' && v) {
            onChange(v);
        }
    };
    var arrValue = typeof value !== 'undefined' && value !== null ? [value] : null;
    var scrollToIndex = function (index) {
        if (!dropdownRef.current) {
            return;
        }
        var elements = dropdownRef.current.querySelectorAll('div[role=option]');
        scrollIntoView(elements[index], dropdownRef.current);
    };
    var _g = useSelect({
        options: options,
        value: arrValue,
        onChange: handlerChangeValue,
        optionsRef: dropdownRef,
        controlRef: controlRef,
        scrollToIndex: scrollToIndex,
        disabled: disabled,
        getOptionLabel: getOptionLabel
    }), visibleOptions = _g.visibleOptions, highlightedIndex = _g.highlightedIndex, getToggleProps = _g.getToggleProps, getOptionProps = _g.getOptionProps, isOpen = _g.isOpen, setOpen = _g.setOpen;
    var handleInputFocus = function (e) {
        if (!disabled) {
            if (!isFocused) {
                setIsFocused(true);
            }
            if (typeof onFocus === 'function') {
                onFocus(e);
            }
        }
    };
    var handleInputBlur = function (e) {
        var _a;
        if (isOpen) {
            (_a = toggleRef.current) === null || _a === void 0 ? void 0 : _a.focus();
            return;
        }
        if (isFocused) {
            setIsFocused(false);
            if (typeof onBlur === 'function') {
                onBlur(e);
            }
        }
    };
    var handleToggleDropdown = function () {
        var _a;
        if (isOpen) {
            setOpen(false);
            setIsFocused(false);
        }
        else {
            setOpen(true);
            setIsFocused(true);
            (_a = toggleRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        }
    };
    return (React.createElement(SelectContainer, __assign({ focused: isFocused, disabled: disabled, size: size, view: view, form: form }, restProps),
        React.createElement("div", { className: cnSelect('Control'), ref: controlRef, "aria-expanded": isOpen, "aria-haspopup": "listbox", id: id },
            React.createElement("div", { className: cnSelect('ControlInner') },
                React.createElement("div", { className: cnSelect('ControlValueContainer') },
                    React.createElement("input", __assign({}, getToggleProps(), { type: "button", name: name, onFocus: handleInputFocus, onBlur: handleInputBlur, "aria-label": ariaLabel, ref: toggleRef, className: cnSelect('FakeField'), readOnly: true })),
                    arrValue ? (React.createElement("span", { className: cnSelect('ControlValue'), title: getOptionLabel(arrValue[0]) }, getOptionLabel(arrValue[0]))) : (React.createElement("span", { className: cnSelect('Placeholder'), title: "placeholder" }, placeholder || '')))),
            React.createElement("span", { className: cnSelect('Indicators') },
                React.createElement("button", { type: "button", className: cnSelect('IndicatorsDropdown'), tabIndex: -1, onClick: handleToggleDropdown },
                    React.createElement(IconSelect, { size: "xs", className: cnSelect('DropdownIndicatorIcon') })))),
        React.createElement(SelectDropdown, { isOpen: isOpen, size: size, controlRef: controlRef, visibleOptions: visibleOptions, highlightedIndex: highlightedIndex, getOptionProps: getOptionProps, dropdownRef: dropdownRef, id: id, selectedValues: arrValue, getOptionLabel: getOptionLabel, form: getSelectDropdownForm(form), className: dropdownClassName })));
};
