import { __values } from "tslib";
export var defaultGroupId = 'context-menu-no-group';
export var contextMenuSizes = ['m', 's', 'l'];
export var contextMenuDefaultSize = contextMenuSizes[0];
export var contextMenuAccent = ['alert', 'warning', 'success'];
export var contextMenuPropSubMenuDirections = [
    'rightStartUp',
    'rightStartDown',
    'leftStartUp',
    'leftStartDown',
];
export var contextMenuPropDefaultSubMenuDirection = contextMenuPropSubMenuDirections[0];
export function getGroups(items, getGroupId, sortGroup) {
    var e_1, _a;
    if (typeof getGroupId === 'function') {
        var groups = [];
        var _loop_1 = function (item) {
            var id = getGroupId(item) || defaultGroupId;
            var index = groups.findIndex(function (group) { return group.id === id; });
            if (index >= 0) {
                groups[index].items.push(item);
            }
            else {
                var group = { id: id, items: [item] };
                groups.push(group);
            }
        };
        try {
            for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
                var item = items_1_1.value;
                _loop_1(item);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (items_1_1 && !items_1_1.done && (_a = items_1["return"])) _a.call(items_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (typeof sortGroup === 'function') {
            groups.sort(function (a, b) { return sortGroup(a.id, b.id); });
        }
        return groups;
    }
    return [{ items: items, id: defaultGroupId }];
}
