import React from 'react';
import { CheckboxProps } from '../../Checkbox/Checkbox';
import { EventInterceptorHandler } from '../EventInterceptor';
export declare const useCheckboxEventsHandler: (props: CheckboxProps, handler: EventInterceptorHandler, checkboxRef: React.RefObject<HTMLLabelElement>) => {
    checked: boolean | undefined;
    size?: "m" | "l" | undefined;
    view?: "ghost" | "primary" | undefined;
    align?: "center" | "top" | undefined;
    disabled?: boolean | undefined;
    intermediate?: boolean | undefined;
    label?: string | undefined;
    onChange?: import("../../Checkbox/Checkbox").CheckboxPropOnChange | undefined;
    name?: string | undefined;
    onFocus?: ((event: React.FocusEvent<HTMLInputElement>) => void) | undefined;
    onBlur?: ((event: React.FocusEvent<HTMLInputElement>) => void) | undefined;
    autoFocus?: boolean | undefined;
    readOnly?: boolean | undefined;
    required?: boolean | undefined;
    step?: string | number | undefined;
    tabIndex?: number | undefined;
    inputRef?: ((instance: HTMLInputElement | null) => void) | React.RefObject<HTMLInputElement> | null | undefined;
    children?: undefined;
    defaultChecked?: boolean | undefined;
    defaultValue?: string | number | readonly string[] | undefined;
    suppressContentEditableWarning?: boolean | undefined;
    suppressHydrationWarning?: boolean | undefined;
    accessKey?: string | undefined;
    className?: string | undefined;
    contentEditable?: boolean | "true" | "false" | "inherit" | undefined;
    contextMenu?: string | undefined;
    dir?: string | undefined;
    draggable?: boolean | "true" | "false" | undefined;
    hidden?: boolean | undefined;
    id?: string | undefined;
    lang?: string | undefined;
    placeholder?: string | undefined;
    slot?: string | undefined;
    spellCheck?: boolean | "true" | "false" | undefined;
    style?: React.CSSProperties | undefined;
    title?: string | undefined;
    translate?: "yes" | "no" | undefined;
    radioGroup?: string | undefined;
    role?: string | undefined;
    about?: string | undefined;
    datatype?: string | undefined;
    inlist?: any;
    prefix?: string | undefined;
    property?: string | undefined;
    resource?: string | undefined;
    typeof?: string | undefined;
    vocab?: string | undefined;
    autoCapitalize?: string | undefined;
    autoCorrect?: string | undefined;
    autoSave?: string | undefined;
    color?: string | undefined;
    itemProp?: string | undefined;
    itemScope?: boolean | undefined;
    itemType?: string | undefined;
    itemID?: string | undefined;
    itemRef?: string | undefined;
    results?: number | undefined;
    security?: string | undefined;
    unselectable?: "on" | "off" | undefined;
    inputMode?: "search" | "text" | "none" | "tel" | "url" | "email" | "numeric" | "decimal" | undefined;
    is?: string | undefined;
    'aria-activedescendant'?: string | undefined;
    'aria-atomic'?: boolean | "true" | "false" | undefined;
    'aria-autocomplete'?: "none" | "inline" | "list" | "both" | undefined;
    'aria-busy'?: boolean | "true" | "false" | undefined;
    'aria-checked'?: boolean | "true" | "false" | "mixed" | undefined;
    'aria-colcount'?: number | undefined;
    'aria-colindex'?: number | undefined;
    'aria-colspan'?: number | undefined;
    'aria-controls'?: string | undefined;
    'aria-current'?: boolean | "time" | "true" | "false" | "page" | "step" | "location" | "date" | undefined;
    'aria-describedby'?: string | undefined;
    'aria-details'?: string | undefined;
    'aria-disabled'?: boolean | "true" | "false" | undefined;
    'aria-dropeffect'?: "link" | "none" | "copy" | "execute" | "move" | "popup" | undefined;
    'aria-errormessage'?: string | undefined;
    'aria-expanded'?: boolean | "true" | "false" | undefined;
    'aria-flowto'?: string | undefined;
    'aria-grabbed'?: boolean | "true" | "false" | undefined;
    'aria-haspopup'?: boolean | "dialog" | "menu" | "true" | "false" | "listbox" | "tree" | "grid" | undefined;
    'aria-hidden'?: boolean | "true" | "false" | undefined;
    'aria-invalid'?: boolean | "true" | "false" | "grammar" | "spelling" | undefined;
    'aria-keyshortcuts'?: string | undefined;
    'aria-label'?: string | undefined;
    'aria-labelledby'?: string | undefined;
    'aria-level'?: number | undefined;
    'aria-live'?: "off" | "assertive" | "polite" | undefined;
    'aria-modal'?: boolean | "true" | "false" | undefined;
    'aria-multiline'?: boolean | "true" | "false" | undefined;
    'aria-multiselectable'?: boolean | "true" | "false" | undefined;
    'aria-orientation'?: "horizontal" | "vertical" | undefined;
    'aria-owns'?: string | undefined;
    'aria-placeholder'?: string | undefined;
    'aria-posinset'?: number | undefined;
    'aria-pressed'?: boolean | "true" | "false" | "mixed" | undefined;
    'aria-readonly'?: boolean | "true" | "false" | undefined;
    'aria-relevant'?: "text" | "additions" | "additions removals" | "additions text" | "all" | "removals" | "removals additions" | "removals text" | "text additions" | "text removals" | undefined;
    'aria-required'?: boolean | "true" | "false" | undefined;
    'aria-roledescription'?: string | undefined;
    'aria-rowcount'?: number | undefined;
    'aria-rowindex'?: number | undefined;
    'aria-rowspan'?: number | undefined;
    'aria-selected'?: boolean | "true" | "false" | undefined;
    'aria-setsize'?: number | undefined;
    'aria-sort'?: "none" | "ascending" | "descending" | "other" | undefined;
    'aria-valuemax'?: number | undefined;
    'aria-valuemin'?: number | undefined;
    'aria-valuenow'?: number | undefined;
    'aria-valuetext'?: string | undefined;
    dangerouslySetInnerHTML?: {
        __html: string;
    } | undefined;
    onCopy?: ((event: React.ClipboardEvent<HTMLLabelElement>) => void) | undefined;
    onCopyCapture?: ((event: React.ClipboardEvent<HTMLLabelElement>) => void) | undefined;
    onCut?: ((event: React.ClipboardEvent<HTMLLabelElement>) => void) | undefined;
    onCutCapture?: ((event: React.ClipboardEvent<HTMLLabelElement>) => void) | undefined;
    onPaste?: ((event: React.ClipboardEvent<HTMLLabelElement>) => void) | undefined;
    onPasteCapture?: ((event: React.ClipboardEvent<HTMLLabelElement>) => void) | undefined;
    onCompositionEnd?: ((event: React.CompositionEvent<HTMLLabelElement>) => void) | undefined;
    onCompositionEndCapture?: ((event: React.CompositionEvent<HTMLLabelElement>) => void) | undefined;
    onCompositionStart?: ((event: React.CompositionEvent<HTMLLabelElement>) => void) | undefined;
    onCompositionStartCapture?: ((event: React.CompositionEvent<HTMLLabelElement>) => void) | undefined;
    onCompositionUpdate?: ((event: React.CompositionEvent<HTMLLabelElement>) => void) | undefined;
    onCompositionUpdateCapture?: ((event: React.CompositionEvent<HTMLLabelElement>) => void) | undefined;
    onFocusCapture?: ((event: React.FocusEvent<HTMLLabelElement>) => void) | undefined;
    onBlurCapture?: ((event: React.FocusEvent<HTMLLabelElement>) => void) | undefined;
    onChangeCapture?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onBeforeInput?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onBeforeInputCapture?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onInput?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onInputCapture?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onReset?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onResetCapture?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onSubmit?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onSubmitCapture?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onInvalid?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onInvalidCapture?: ((event: React.FormEvent<HTMLLabelElement>) => void) | undefined;
    onLoad?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onLoadCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onError?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onErrorCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onKeyDown?: ((event: React.KeyboardEvent<HTMLLabelElement>) => void) | undefined;
    onKeyDownCapture?: ((event: React.KeyboardEvent<HTMLLabelElement>) => void) | undefined;
    onKeyPress?: ((event: React.KeyboardEvent<HTMLLabelElement>) => void) | undefined;
    onKeyPressCapture?: ((event: React.KeyboardEvent<HTMLLabelElement>) => void) | undefined;
    onKeyUp?: ((event: React.KeyboardEvent<HTMLLabelElement>) => void) | undefined;
    onKeyUpCapture?: ((event: React.KeyboardEvent<HTMLLabelElement>) => void) | undefined;
    onAbort?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onAbortCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onCanPlay?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onCanPlayCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onCanPlayThrough?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onCanPlayThroughCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onDurationChange?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onDurationChangeCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onEmptied?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onEmptiedCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onEncrypted?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onEncryptedCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onEnded?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onEndedCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onLoadedData?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onLoadedDataCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onLoadedMetadata?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onLoadedMetadataCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onLoadStart?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onLoadStartCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onPause?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onPauseCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onPlay?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onPlayCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onPlaying?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onPlayingCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onProgress?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onProgressCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onRateChange?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onRateChangeCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onSeeked?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onSeekedCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onSeeking?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onSeekingCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onStalled?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onStalledCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onSuspend?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onSuspendCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onTimeUpdate?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onTimeUpdateCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onVolumeChange?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onVolumeChangeCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onWaiting?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onWaitingCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onAuxClick?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onAuxClickCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onClick?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onClickCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onContextMenu?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onContextMenuCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onDoubleClick?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onDoubleClickCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onDrag?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragEnd?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragEndCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragEnter?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragEnterCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragExit?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragExitCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragLeave?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragLeaveCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragOver?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragOverCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragStart?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDragStartCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDrop?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onDropCapture?: ((event: React.DragEvent<HTMLLabelElement>) => void) | undefined;
    onMouseDown?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseDownCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseEnter?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseLeave?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseMove?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseMoveCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseOut?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseOutCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseOver?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseOverCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseUp?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onMouseUpCapture?: ((event: React.MouseEvent<HTMLLabelElement, MouseEvent>) => void) | undefined;
    onSelect?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onSelectCapture?: ((event: React.SyntheticEvent<HTMLLabelElement, Event>) => void) | undefined;
    onTouchCancel?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onTouchCancelCapture?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onTouchEnd?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onTouchEndCapture?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onTouchMove?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onTouchMoveCapture?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onTouchStart?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onTouchStartCapture?: ((event: React.TouchEvent<HTMLLabelElement>) => void) | undefined;
    onPointerDown?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerDownCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerMove?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerMoveCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerUp?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerUpCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerCancel?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerCancelCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerEnter?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerEnterCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerLeave?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerLeaveCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerOver?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerOverCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerOut?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onPointerOutCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onGotPointerCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onGotPointerCaptureCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onLostPointerCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onLostPointerCaptureCapture?: ((event: React.PointerEvent<HTMLLabelElement>) => void) | undefined;
    onScroll?: ((event: React.UIEvent<HTMLLabelElement, UIEvent>) => void) | undefined;
    onScrollCapture?: ((event: React.UIEvent<HTMLLabelElement, UIEvent>) => void) | undefined;
    onWheel?: ((event: React.WheelEvent<HTMLLabelElement>) => void) | undefined;
    onWheelCapture?: ((event: React.WheelEvent<HTMLLabelElement>) => void) | undefined;
    onAnimationStart?: ((event: React.AnimationEvent<HTMLLabelElement>) => void) | undefined;
    onAnimationStartCapture?: ((event: React.AnimationEvent<HTMLLabelElement>) => void) | undefined;
    onAnimationEnd?: ((event: React.AnimationEvent<HTMLLabelElement>) => void) | undefined;
    onAnimationEndCapture?: ((event: React.AnimationEvent<HTMLLabelElement>) => void) | undefined;
    onAnimationIteration?: ((event: React.AnimationEvent<HTMLLabelElement>) => void) | undefined;
    onAnimationIterationCapture?: ((event: React.AnimationEvent<HTMLLabelElement>) => void) | undefined;
    onTransitionEnd?: ((event: React.TransitionEvent<HTMLLabelElement>) => void) | undefined;
    onTransitionEndCapture?: ((event: React.TransitionEvent<HTMLLabelElement>) => void) | undefined;
};
