import { __assign, __rest } from "tslib";
import './Informer.css';
import React from 'react';
import { classnames } from '@bem-react/classnames';
import { cn } from '../../utils/bem';
import { Text } from '../Text/Text';
import { useTheme } from '../Theme/Theme';
export var informerPropView = ['filled', 'bordered'];
export var informerPropViewDefault = informerPropView[0];
export var informerPropStatus = ['success', 'system', 'alert', 'alert', 'warning'];
export var informerPropStatusDefault = informerPropStatus[0];
export var cnInformer = cn('Informer');
export var Informer = React.forwardRef(function (props, ref) {
    var view = props.view, status = props.status, icon = props.icon, label = props.label, title = props.title, children = props.children, otherProps = __rest(props, ["view", "status", "icon", "label", "title", "children"]);
    var Icon = icon;
    var withIcon = !!icon;
    var themeClassNames = useTheme().themeClassNames;
    var className = status !== 'system' && view === 'filled'
        ? classnames(props.className, themeClassNames.color.accent)
        : props.className;
    return (React.createElement("div", __assign({}, otherProps, { className: cnInformer({
            view: view,
            status: status,
            withIcon: withIcon
        }, [className]), ref: ref }),
        Icon && React.createElement(Icon, { className: cnInformer('Icon'), size: "s" }),
        Icon ? (React.createElement("div", { className: cnInformer('Content') },
            title && React.createElement(Text, { weight: "bold" }, title),
            label || children)) : (React.createElement(React.Fragment, null,
            title && React.createElement(Text, { weight: "bold" }, title),
            label || children))));
});
