import './TabsTab.css';
import React, { forwardRef } from 'react';
import { cnMixFocus } from '../../../mixs/MixFocus/MixFocus';
import { cn } from '../../../utils/bem';
export var cnTabsTab = cn('TabsTab');
export var TabsTab = forwardRef(function (props, ref) {
    var label = props.label, onChange = props.onChange, checked = props.checked, onlyIcon = props.onlyIcon, Icon = props.icon, iconSize = props.iconSize, className = props.className;
    return (React.createElement("button", { className: cnTabsTab({ checked: checked, onlyIcon: onlyIcon }, [cnMixFocus({ before: true }), className]), onClick: checked ? undefined : onChange, ref: ref, role: "tab", type: "button", title: onlyIcon ? label : undefined },
        Icon && React.createElement(Icon, { className: cnTabsTab('Icon'), size: iconSize }),
        !onlyIcon && label));
});
