import { __read } from "tslib";
import { useCallback, useLayoutEffect, useState } from 'react';
var getElementSize = function (el) {
    if (!el) {
        return { width: 0, height: 0 };
    }
    var _a = el.getBoundingClientRect(), width = _a.width, height = _a.height;
    return {
        width: Math.floor(width),
        height: Math.floor(height)
    };
};
export function useComponentSize(ref) {
    var _a = __read(useState(getElementSize(ref && ref.current)), 2), componentSize = _a[0], setComponentSize = _a[1];
    var handleResize = useCallback(function () {
        if (ref.current) {
            setComponentSize(getElementSize(ref.current));
        }
    }, [ref]);
    useLayoutEffect(function () {
        if (!ref.current) {
            return;
        }
        handleResize();
        var resizeObserver = new ResizeObserver(handleResize);
        resizeObserver.observe(ref.current);
        return function () {
            resizeObserver.disconnect();
        };
    }, [ref, handleResize]);
    return componentSize;
}
