import { __read, __spread } from "tslib";
import React from 'react';
export var useDebounce = function (fn, time) {
    if (time === void 0) { time = 0; }
    var ref = React.useRef(null);
    var fnRef = React.useRef();
    fnRef.current = fn;
    React.useEffect(function () {
        return function () {
            ref.current && clearTimeout(ref.current);
        };
    }, [time]);
    return React.useCallback(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (ref.current) {
            clearTimeout(ref.current);
        }
        ref.current = setTimeout(function () {
            ref.current = null;
            if (typeof fnRef.current === 'function') {
                fnRef.current.apply(fnRef, __spread(args));
            }
        }, time);
    }, [time]);
};
